码迷,mamicode.com
首页 > 其他好文 > 详细

【状压DP】【HDOJ1074】

时间:2018-09-17 23:05:24      阅读:401      评论:0      收藏:0      [点我收藏+]

标签:nts   put   ber   i++   The   nim   cts   pos   range   

http://acm.hdu.edu.cn/showproblem.php?pid=1074

 

 

Doing Homework

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 12269    Accepted Submission(s): 5911

Problem Description
Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.
 
Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject‘s name, each string will at most has 100 characters) and two integers D(the deadline of the subject), C(how many days will it take Ignatius to finish this subject‘s homework). 

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.
 
Output
For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.
 
Sample Input
2 3 Computer 3 3 English 20 1 Math 3 2 3 Computer 3 3 English 6 3 Math 6 3
 
Sample Output
2 Computer Math English 3 Computer English Math
Hint
In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the word "English" appears earlier than the word "Math", so we choose the first order. That is so-called alphabet order.
 
 
题目大意:有N个作业(N<=15),每个作业需耗时,有一个截止期限。超期多少天就要扣多少分。问最少被扣多少分,且按字典序输出做作业顺序。
题解:由于N<=15,所以可以想到使用状压DP。
特别地,此类DP问题,需要满足同级的进行递推的顺序不影响结果,比如状态 5 (101)与6(110)的顺序无关紧要,因为不是由它推过来的,所以这道题可以使用状压DP(如果5与6出现的顺序影响结果的话就不能使用状压DP了)
技术分享图片
 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 using namespace std;
 5 struct sta {
 6     char ss[150];
 7     int tim;
 8     int del;
 9 }st[16],skt[1<<15];
10 int dp[1 << 15];
11 int pre[1 << 15];
12 void print(int x,int y) {
13     if (x == 0) {
14         return;
15     }
16     print(x-(1<<y), pre[x-(1<<y)]);
17     printf("%s\n",st[y].ss);
18 }
19 int main() {
20     int t;
21     scanf("%d",&t);
22     while (t--) {
23         int n;
24         scanf("%d",&n);
25         for (int i = 0; i < n; i++) {
26             scanf("%s%d%d",st[i].ss,&st[i].del,&st[i].tim);
27         }
28         memset(dp, 0x3f3f3f3f, sizeof(dp));
29         dp[0] = 0;
30         skt[0].tim = 0;
31         for (int i = 1; i < (1 << n); i++) {
32             for (int j = n - 1; j >= 0; j--) {
33                 if ((1 << j)&i) {
34                     int cost = skt[i - (1 << j)].tim + st[j].tim - st[j].del;
35                     if (cost < 0)cost = 0;
36                     if (cost + dp[i-(1<<j)] < dp[i]) {
37                         dp[i] = cost + dp[i - (1 << j)];
38                         skt[i].tim = skt[i - (1 << j)].tim + st[j].tim;
39                         pre[i] = j;
40                     }
41                 }
42             }
43         }
44         cout << dp[(1 << n) - 1] << endl;
45         print((1<<n)-1,pre[(1<<n)-1]);
46     }
47     return 0;
48 }
View Code

 

 

【状压DP】【HDOJ1074】

标签:nts   put   ber   i++   The   nim   cts   pos   range   

原文地址:https://www.cnblogs.com/MekakuCityActor/p/9665265.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!